Index: netwerk/cookie/public/nsICookieContainer.idl
===================================================================
RCS file: netwerk/cookie/public/nsICookieContainer.idl
diff -N netwerk/cookie/public/nsICookieContainer.idl
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ netwerk/cookie/public/nsICookieContainer.idl	14 May 2007 09:24:11 -0000
@@ -0,0 +1,64 @@
+/* ***** BEGIN LICENSE BLOCK *****
+ * Version: MPL 1.1/GPL 2.0/LGPL 2.1
+ *
+ * The contents of this file are subject to the Mozilla Public License Version
+ * 1.1 (the "License"); you may not use this file except in compliance with
+ * the License. You may obtain a copy of the License at
+ * http://www.mozilla.org/MPL/
+ *
+ * Software distributed under the License is distributed on an "AS IS" basis,
+ * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
+ * for the specific language governing rights and limitations under the
+ * License.
+ *
+ * The Original Code is the Cookie Containers Code.
+ *
+ * The Initial Developer of the Original Code is
+ * Loune Lam <lpgcritter at nasquan dot com>.
+ *
+ * Portions created by the Initial Developer are Copyright (C) 2007
+ * the Initial Developer. All Rights Reserved.
+ *
+ * Contributor(s):
+ *   Loune Lam <lpgcritter at nasquan dot com>
+ *
+ * Alternatively, the contents of this file may be used under the terms of
+ * either the GNU General Public License Version 2 or later (the "GPL"), or
+ * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
+ * in which case the provisions of the GPL or the LGPL are applicable instead
+ * of those above. If you wish to allow use of your version of this file only
+ * under the terms of either the GPL or the LGPL, and not to allow others to
+ * use your version of this file under the terms of the MPL, indicate your
+ * decision by deleting the provisions above and replace them with the notice
+ * and other provisions required by the GPL or the LGPL. If you do not delete
+ * the provisions above, a recipient may use your version of this file under
+ * the terms of any one of the MPL, the GPL or the LGPL.
+ *
+ * ***** END LICENSE BLOCK ***** */
+
+#include "nsISupports.idl"
+
+interface nsIURI;
+interface nsICookie;
+interface nsIArray;
+
+[scriptable, uuid(a5556dc0-1ca9-46e2-a30c-303d70976a7e)]
+interface nsICookieContainer : nsISupports
+{
+
+    void init(in string aContainerId);
+
+    //
+    // An unique identifier for the container, mainly used by session restore to save the container
+    // must be in form of contractID
+    readonly attribute string containerId;
+
+    // set a single cookie to the container
+    // will be responsible for notifying observers (ie cookie-changed)
+    void setCookie(in nsIURI aHostURI, in nsICookie cookie);
+	
+    // called by getCookie functions to retrieve the cookies satifsfying the criteria
+    nsIArray getCookieList(in nsIURI aHostURI, in string aName, in boolean aHttpBound);
+
+
+};
Index: netwerk/cookie/public/nsICookieService.idl
===================================================================
RCS file: /cvsroot/mozilla/netwerk/cookie/public/nsICookieService.idl,v
retrieving revision 1.9
diff -p -U 8 -r1.9 nsICookieService.idl
--- netwerk/cookie/public/nsICookieService.idl	14 Mar 2007 17:22:01 -0000	1.9
+++ netwerk/cookie/public/nsICookieService.idl	14 May 2007 09:24:11 -0000
@@ -15,16 +15,17 @@
  * The Original Code is mozilla.org code.
  *
  * The Initial Developer of the Original Code is
  * Netscape Communications Corporation.
  * Portions created by the Initial Developer are Copyright (C) 1998
  * the Initial Developer. All Rights Reserved.
  *
  * Contributor(s):
+ *   Loune Lam <lpgcritter at nasquan dot com>
  *
  * Alternatively, the contents of this file may be used under the terms of
  * either the GNU General Public License Version 2 or later (the "GPL"), or
  * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
  * in which case the provisions of the GPL or the LGPL are applicable instead
  * of those above. If you wish to allow use of your version of this file only
  * under the terms of either the GPL or the LGPL, and not to allow others to
  * use your version of this file under the terms of the MPL, indicate your
@@ -35,16 +36,17 @@
  *
  * ***** END LICENSE BLOCK ***** */
 
 #include "nsISupports.idl"
 
 interface nsIURI;
 interface nsIPrompt;
 interface nsIChannel;
+interface nsICookieContainer;
 
 /**
  * nsICookieService
  *
  * Provides methods for setting and getting cookies in the context of a
  * page load.  See nsICookieManager for methods to manipulate the cookie
  * database directly.  This separation of interface is mainly historical.
  *
@@ -75,72 +77,80 @@ interface nsIChannel;
  * data   : none.
  */
 [scriptable, uuid(011C3190-1434-11d6-A618-0010A401EB10)]
 interface nsICookieService : nsISupports
 {
   /*
    * Get the complete cookie string associated with the URI.
    *
+   * @param aContainer
+   *        the container the cookie should be retrieved from
    * @param aURI
    *        the URI of the document for which cookies are being queried.
    * @param aChannel
    *        the channel used to load the document.  this parameter may be null,
    *        but it is strongly recommended that a non-null value be provided to
    *        ensure that the cookie privacy preferences are honored.
    *
    * @return the resulting cookie string
    */
-  string getCookieString(in nsIURI aURI, in nsIChannel aChannel);
+  string getCookieString(in nsICookieContainer aContainer, in nsIURI aURI, in nsIChannel aChannel);
 
   /*
    * Get the complete cookie string associated with the URI.
    *
    * This function is NOT redundant with getCookieString, as the result
    * will be different based on httponly (see bug 178993)
    *
+   * @param aContainer
+   *        the container the cookie should be retrieved from
    * @param aURI
    *        the URI of the document for which cookies are being queried.
    * @param aFirstURI
    *        the URI that the user originally typed in or clicked on to initiate
    *        the load of the document referenced by aURI.
    * @param aChannel
    *        the channel used to load the document.  this parameter may be null,
    *        but it is strongly recommended that a non-null value be provided to
    *        ensure that the cookie privacy preferences are honored.
    *
    * @return the resulting cookie string
    */
-  string getCookieStringFromHttp(in nsIURI aURI, in nsIURI aFirstURI, in nsIChannel aChannel);
+  string getCookieStringFromHttp(in nsICookieContainer aContainer, in nsIURI aURI, in nsIURI aFirstURI, in nsIChannel aChannel);
 
   /*
    * Set the cookie string associated with the URI.
    *
+   * @param aContainer
+   *        the container the cookie should be put into
    * @param aURI
    *        the URI of the document for which cookies are being set.
    * @param aPrompt
    *        the prompt to use for all user-level cookie notifications.
    * @param aCookie
    *        the cookie string to set.
    * @param aChannel
    *        the channel used to load the document.  this parameter may be null,
    *        but it is strongly recommended that a non-null value be provided to
    *        ensure that the cookie privacy preferences are honored.
    *
    * XXX should be able to allow null aPrompt, since nsIPrompt can be queryied
    * from aChannel.
    */
-  void setCookieString(in nsIURI aURI, in nsIPrompt aPrompt, in string aCookie, in nsIChannel aChannel);
+  void setCookieString(in nsICookieContainer aContainer, in nsIURI aURI, in nsIPrompt aPrompt, in string aCookie, in nsIChannel aChannel);
 
   /*
    * Set the cookie string and expires associated with the URI.
    *
    * This function is NOT redundant with setCookieString, as the result
    * will be different based on httponly (see bug 178993)
    *
+   * @param aContainer
+   *        the container the cookie should be put into
    * @param aURI
    *        the URI of the document for which cookies are being set.
    * @param aFirstURI
    *        the URI that the user originally typed in or clicked on to initiate
    *        the load of the document referenced by aURI.
    * @param aPrompt
    *        the prompt to use for all user-level cookie notifications.
    * @param aCookie
@@ -148,17 +158,37 @@ interface nsICookieService : nsISupports
    * @param aServerTime
    *        the expiry information of the cookie (the Date header from the HTTP
    *        response).
    * @param aChannel
    *        the channel used to load the document.  this parameter may be null,
    *        but it is strongly recommended that a non-null value be provided to
    *        ensure that the cookie privacy preferences are honored.
    */
-  void setCookieStringFromHttp(in nsIURI aURI, in nsIURI aFirstURI, in nsIPrompt aPrompt, in string aCookie, in string aServerTime, in nsIChannel aChannel);
+  void setCookieStringFromHttp(in nsICookieContainer aContainer, in nsIURI aURI, in nsIURI aFirstURI, in nsIPrompt aPrompt, in string aCookie, in string aServerTime, in nsIChannel aChannel);
 
   /**
    * This attribute really doesn't belong on this interface.  CVS blame will
    * tell you why it is here.  It remains until we can find a better home for
    * it.  Read the source if you want to know what it does :-(
    */
   readonly attribute boolean cookieIconIsVisible;
+
+  /**
+   * The default container that newly created channels and docshells use
+   */
+  attribute nsICookieContainer defaultContainer;
+
+  /**
+   * Get the container from the list of active containers by the aContainerId specified.
+   * 
+   * If container not found in the list, the container is created from getting the nsICookieContainer contractId from the aContainerId. It'll then be added to the list of active containers
+   * 
+   * This function is mainly used by session restore to get the correct container when restoring the cookies of the session.
+   * 
+   * @param aContainerId
+   *        The containerId which is in the form of contractId (of component)
+   *        concatenated with hash and the name of the container instance
+   *        eg. @mozilla.org/cookie-container;1#mycookiejar
+   */
+  nsICookieContainer getContainer(in string aContainerId);
+
 };
